opal/threads/mutex.h File Reference.TH "opal/threads/mutex.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/threads/mutex.h \- Mutual exclusion functions. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'include/sys/atomic.h'\fP
.br
\fC#include 'mutex_unix.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBOPAL_MUTEX_H\fP   1"
.br
.ti -1c
.RI "#define \fBOPAL_THREAD_LOCK\fP(mutex)"
.br
.RI "\fILock a mutex if \fBopal_using_threads()\fP says that multiple threads may be active in the process. \fP"
.ti -1c
.RI "#define \fBOPAL_THREAD_UNLOCK\fP(mutex)"
.br
.RI "\fIUnlock a mutex if \fBopal_using_threads()\fP says that multiple threads may be active in the process. \fP"
.ti -1c
.RI "#define \fBOPAL_THREAD_SCOPED_LOCK\fP(mutex, action)   (action)"
.br
.RI "\fILock a mutex if \fBopal_using_threads()\fP says that multiple threads may be active in the process for the duration of the specified action. \fP"
.ti -1c
.RI "#define \fBOPAL_THREAD_ADD32\fP(x, y)   (*x += y)"
.br
.RI "\fIUse an atomic operation for increment/decrement if \fBopal_using_threads()\fP indicates that threads are in use by the application or library. \fP"
.ti -1c
.RI "#define \fBOPAL_THREAD_ADD64\fP(x, y)   (*x += y)"
.br
.ti -1c
.RI "#define \fBOPAL_THREAD_ADD_SIZE_T\fP(x, y)   (*x += y)"
.br
.ti -1c
.RI "#define \fBOPAL_LOCK\fP(mutex)   opal_mutex_atomic_lock(mutex)"
.br
.RI "\fIAlways locks a mutex (never compile- or run-time removed). \fP"
.ti -1c
.RI "#define \fBOPAL_UNLOCK\fP(mutex)   opal_mutex_atomic_unlock(mutex)"
.br
.RI "\fIAlways unlocks a mutex (never compile- or run-time removed). \fP"
.ti -1c
.RI "#define \fBOPAL_SCOPED_LOCK\fP(mutex, action)"
.br
.RI "\fILock a mutex for the duration of the specified action. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBopal_mutex_t\fP \fBopal_mutex_t\fP"
.br
.RI "\fIOpaque mutex object. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "static int \fBopal_mutex_trylock\fP (\fBopal_mutex_t\fP *mutex)"
.br
.RI "\fITry to acquire a mutex. \fP"
.ti -1c
.RI "static void \fBopal_mutex_lock\fP (\fBopal_mutex_t\fP *mutex)"
.br
.RI "\fIAcquire a mutex. \fP"
.ti -1c
.RI "static void \fBopal_mutex_unlock\fP (\fBopal_mutex_t\fP *mutex)"
.br
.RI "\fIRelease a mutex. \fP"
.ti -1c
.RI "static int \fBopal_mutex_atomic_trylock\fP (\fBopal_mutex_t\fP *mutex)"
.br
.RI "\fITry to acquire a mutex using atomic operations. \fP"
.ti -1c
.RI "static void \fBopal_mutex_atomic_lock\fP (\fBopal_mutex_t\fP *mutex)"
.br
.RI "\fIAcquire a mutex using atomic operations. \fP"
.ti -1c
.RI "static void \fBopal_mutex_atomic_unlock\fP (\fBopal_mutex_t\fP *mutex)"
.br
.RI "\fIRelease a mutex using atomic operations. \fP"
.ti -1c
.RI "static bool \fBopal_using_threads\fP (void)"
.br
.RI "\fICheck and see if the process is using multiple threads. \fP"
.ti -1c
.RI "static bool \fBopal_set_using_threads\fP (bool have)"
.br
.RI "\fISet whether the process is using multiple threads or not. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC bool \fBopal_uses_threads\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
Mutual exclusion functions. 

Functions for locking of critical sections.
.SH "Define Documentation"
.PP 
.SS "#define OPAL_LOCK(mutex)   opal_mutex_atomic_lock(mutex)"
.PP
Always locks a mutex (never compile- or run-time removed). 
.PP
\fBParameters:\fP
.RS 4
\fImutex\fP A pointer to a opal_mutex_t.
.RE
.PP
Locks the mutex. This is the macro that you should use for mutexes that should always be locked, regardless of whether the process has multiple threads or not. This is useful, for example, with shared memory. 
.SS "#define OPAL_SCOPED_LOCK(mutex, action)"
.PP
\fBValue:\fP
.PP
.nf
do {                                        \
        opal_mutex_lock(mutex);                 \
        (action);                               \
        opal_mutex_unlock(mutex);               \
    } while (0)
.fi
Lock a mutex for the duration of the specified action. 
.PP
\fBParameters:\fP
.RS 4
\fImutex\fP Pointer to a opal_mutex_t to lock. 
.br
\fIaction\fP A scope over which the lock is held.
.RE
.PP
This is the macro that you should use for mutexes that should always be locked, regardless of whether the process has multiple threads or not. This is useful, for example, with shared memory. 
.SS "#define OPAL_THREAD_LOCK(mutex)"
.PP
Lock a mutex if \fBopal_using_threads()\fP says that multiple threads may be active in the process. 
.PP
\fBParameters:\fP
.RS 4
\fImutex\fP Pointer to a opal_mutex_t to lock.
.RE
.PP
If there is a possibility that multiple threads are running in the process (as determined by \fBopal_using_threads()\fP), this function will block waiting to lock the mutex.
.PP
If there is no possibility that multiple threads are running in the process, return immediately. 
.SS "#define OPAL_THREAD_SCOPED_LOCK(mutex, action)   (action)"
.PP
Lock a mutex if \fBopal_using_threads()\fP says that multiple threads may be active in the process for the duration of the specified action. 
.PP
\fBParameters:\fP
.RS 4
\fImutex\fP Pointer to a opal_mutex_t to lock. 
.br
\fIaction\fP A scope over which the lock is held.
.RE
.PP
If there is a possibility that multiple threads are running in the process (as determined by \fBopal_using_threads()\fP), this function will acquire the lock before invoking the specified action and release it on return.
.PP
If there is no possibility that multiple threads are running in the process, invoke the action without acquiring the lock. 
.SS "#define OPAL_THREAD_UNLOCK(mutex)"
.PP
Unlock a mutex if \fBopal_using_threads()\fP says that multiple threads may be active in the process. 
.PP
\fBParameters:\fP
.RS 4
\fImutex\fP Pointer to a opal_mutex_t to unlock.
.RE
.PP
If there is a possibility that multiple threads are running in the process (as determined by \fBopal_using_threads()\fP), this function will unlock the mutex.
.PP
If there is no possibility that multiple threads are running in the process, return immediately without modifying the mutex. 
.SS "#define OPAL_UNLOCK(mutex)   opal_mutex_atomic_unlock(mutex)"
.PP
Always unlocks a mutex (never compile- or run-time removed). 
.PP
\fBParameters:\fP
.RS 4
\fImutex\fP A pointer to a opal_mutex_t.
.RE
.PP
Unlocks the mutex. This is the macro that you should use for mutexes that should always be unlocked, regardless of whether the process has multiple threads or not. This is useful, for example, with shared memory. 
.SH "Function Documentation"
.PP 
.SS "static void opal_mutex_atomic_lock (\fBopal_mutex_t\fP * mutex)\fC [inline, static]\fP"
.PP
Acquire a mutex using atomic operations. 
.PP
\fBParameters:\fP
.RS 4
\fImutex\fP Address of the mutex. 
.RE
.PP

.SS "static int opal_mutex_atomic_trylock (\fBopal_mutex_t\fP * mutex)\fC [inline, static]\fP"
.PP
Try to acquire a mutex using atomic operations. 
.PP
\fBParameters:\fP
.RS 4
\fImutex\fP Address of the mutex. 
.RE
.PP
\fBReturns:\fP
.RS 4
0 if the mutex was acquired, 1 otherwise. 
.RE
.PP

.SS "static void opal_mutex_atomic_unlock (\fBopal_mutex_t\fP * mutex)\fC [inline, static]\fP"
.PP
Release a mutex using atomic operations. 
.PP
\fBParameters:\fP
.RS 4
\fImutex\fP Address of the mutex. 
.RE
.PP

.SS "static void opal_mutex_lock (\fBopal_mutex_t\fP * mutex)\fC [inline, static]\fP"
.PP
Acquire a mutex. 
.PP
\fBParameters:\fP
.RS 4
\fImutex\fP Address of the mutex. 
.RE
.PP

.SS "static int opal_mutex_trylock (\fBopal_mutex_t\fP * mutex)\fC [inline, static]\fP"
.PP
Try to acquire a mutex. 
.PP
\fBParameters:\fP
.RS 4
\fImutex\fP Address of the mutex. 
.RE
.PP
\fBReturns:\fP
.RS 4
0 if the mutex was acquired, 1 otherwise. 
.RE
.PP

.SS "static void opal_mutex_unlock (\fBopal_mutex_t\fP * mutex)\fC [inline, static]\fP"
.PP
Release a mutex. 
.PP
\fBParameters:\fP
.RS 4
\fImutex\fP Address of the mutex. 
.RE
.PP

.SS "static bool opal_set_using_threads (bool have)\fC [inline, static]\fP"
.PP
Set whether the process is using multiple threads or not. 
.PP
\fBParameters:\fP
.RS 4
\fIhave\fP Boolean indicating whether the process is using multiple threads or not.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIopal_using_threads\fP The new return value from \fBopal_using_threads()\fP.
.RE
.PP
This function is used to influence the return value of \fBopal_using_threads()\fP. If configure detected that we have thread support, the return value of future invocations of \fBopal_using_threads()\fP will be the parameter's value. If configure detected that we have no thread support, then the retuen from \fBopal_using_threads()\fP will always be false. 
.SS "static bool opal_using_threads (void)\fC [inline, static]\fP"
.PP
Check and see if the process is using multiple threads. 
.PP
\fBReturn values:\fP
.RS 4
\fItrue\fP If the process may have more than one thread. 
.br
\fIfalse\fP If the process only has a single thread.
.RE
.PP
The value that this function returns is influenced by:
.PP
.IP "\(bu" 2
how MPI_INIT or MPI_INIT_THREAD was invoked,
.IP "\(bu" 2
what the final MPI thread level was determined to be,
.IP "\(bu" 2
whether the OMPI or MPI libraries are multi-threaded (Jan 2003: they're not),
.IP "\(bu" 2
whether configure determined if we have thread support or not
.PP
.PP
MPI_INIT and MPI_INIT_THREAD (specifically, back-end OMPI startup functions) invoke \fBopal_set_using_threads()\fP to influence the value of this function, depending on their situation. Some examples:
.PP
.IP "\(bu" 2
if configure determined that we do not have threads, then this value will always be false.
.PP
.PP
.IP "\(bu" 2
if MPI_INIT is invoked, and the ompi libraries are [still] single-threaded, this value will be false.
.PP
.PP
.IP "\(bu" 2
if MPI_INIT_THREAD is invoked with MPI_THREAD_MULTIPLE, we have thread support, and the final thread level is determined to be MPI_THREAD_MULTIPLE, this value will be true.
.PP
.PP
.IP "\(bu" 2
if the process is a single-threaded OMPI executable (e.g., mpicc), this value will be false.
.PP
.PP
Hence, this function will return false if there is guaranteed to only be one thread in the process. If there is even the possibility that we may have multiple threads, true will be returned. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
